/*
	wiax.dll version 0.9.9f

    This source code is  (c) 2003, 2004 Dan Toma under the GNU LGPL, version 2.0 or greater

    It uses the 'libiaxclient.a' library, required during the link phase, 
	which is (c) 2003 HorizonLive, 
    licensed under the GNU LGPL, version 2.0 or greater"
	It can be downloaded in source form and compiled from:
		http://iaxclient.sourceforge.net
    
    This library contains the libiax or libiax2 library, 
	which is (c) 2001 Linux Support Services, Inc.
    also licensed under the GNU LGPL, version 2.0 or greater
    
    It also contains parts of the PortAudio Portable Real-Time Audio Library
    Copyright (c) 1999-2000 Ross Bencina and Phil Burk
    
    It also contains the GSM 06.10 implementation
    Copyright (c) 1992, 1993, 1994 by Jutta Degener and Carsten Bormann,
    Technische Universitaet Berlin"
*/

#include "wiax.h"

BOOL WINAPI
DllMain (HANDLE hDll, DWORD dwReason, LPVOID lpReserved)
{
    switch (dwReason)
    {
        case DLL_PROCESS_ATTACH:
            // Code to run when the DLL is loaded
            break;

        case DLL_PROCESS_DETACH:
            // Code to run when the DLL is freed
            break;

        case DLL_THREAD_ATTACH:
            // Code to run when a thread is created during the DLL's lifetime
            break;

        case DLL_THREAD_DETACH:
            // Code to run when a thread ends normally.
            break;
    }
    return TRUE;
}


//***************************************************************************
EXPORT void STDCALL IAX_EnableDebug(void)
{
	iaxc_enable_debug();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_DisableDebug(void)
{
	iaxc_disable_debug();
}
//--------------------------------------------------------------------------//
EXPORT int STDCALL IAX_Initialize(int audType, int nCalls)
{
	return(iaxc_initialize(audType, nCalls));
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SetCallerID(char *name, char *number)
{
	iaxc_set_callerid(name, number);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_Shutdown(void)
{
	iaxc_shutdown();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SetFormats(int preferred, int allowed)
{
	iaxc_set_formats(preferred, allowed);
//	iaxc_set_encode_format(preferred);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_ProcessCalls()
{
	iaxc_process_calls();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_StartProcessingThread()
{
	iaxc_start_processing_thread();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_StopProcessingThread()
{
	iaxc_stop_processing_thread();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_Call(char *num)
{
//	MessageBox(NULL, num, "Title", MB_OK);
	iaxc_call(num);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_Register(char *user, char *pass, char *host)
{
	iaxc_register(user, pass, host);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_AnswerCall(int callNo)
{
	iaxc_answer_call(callNo);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_DumpAllCalls()
{
	iaxc_dump_all_calls();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_DumpCall()
{
	iaxc_dump_call();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_RejectCall()
{
	iaxc_reject_call();
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SendDTMF(char digit)
{
//	char txt;
	
//	sprintf((char *)txt, "%s", digit);
//	MessageBox(NULL, txt,"Title",MB_OK);
	iaxc_send_dtmf(digit);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_milliSleep(long ms)
{
	iaxc_millisleep(ms);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SetSilenceThreshold(int thr)
{
//	char txt[30];
	double dblthr;
	dblthr=(double)thr;
//	sprintf(txt, "Threshold:   %g", dblthr);
//	MessageBox(NULL, txt,"Title",MB_OK);
	iaxc_set_silence_threshold(dblthr);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SetAudioOutput(int mode)
{
	iaxc_set_audio_output(mode);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SelectCall(int callNo)
{
	iaxc_select_call(callNo);
}
//--------------------------------------------------------------------------//
EXPORT int STDCALL IAX_AudioDevicesGetSatus(int *nDevs, int *in, int *out, int *ring)
{
	int ret=0;
	struct iaxc_audio_device *devices;
	ret=iaxc_audio_devices_get((struct iaxc_audio_device**)&devices,(int *)nDevs,(int *)in,(int *)out,(int *)ring);
	return(ret);
}
//--------------------------------------------------------------------------//
EXPORT int STDCALL IAX_AudioDevicesGetOne(int DevNr, char *DevName, long *capabilities, int *devID)
{
	int n=0;
	int nDevs=0;
	int in=0;
	int out=0;
	int ring=0;
	struct iaxc_audio_device *devices;
	n=iaxc_audio_devices_get((struct iaxc_audio_device**)&devices, &nDevs, &in, &out, &ring);
	*capabilities=devices[DevNr].capabilities;
	*devID=devices[DevNr].devID;
	strcpy(DevName, (char *)devices[DevNr].name);
	return n;
}
//--------------------------------------------------------------------------//
EXPORT int STDCALL IAX_AudioDevicesSet(int input, int output, int ring)
{
	return(iaxc_audio_devices_set(input, output, ring));
}

//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SetEventCallback()
{
	iaxc_set_event_callback(iaxc_callback);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL SetVBCallback(cb_levels_t fnCBLevel, cb_text_t fnCBText, cb_state_t fnCBState, cb_reg_t fnCBReg)
{
	vb_cb_levels=fnCBLevel;
	vb_cb_text=fnCBText;
	vb_cb_state=fnCBState;
	vb_cb_reg=fnCBReg;
}

//--------------------------------------------------------------------------//
int iaxc_callback(iaxc_event e)
{
	int ret=0;
	//char *msg;

	WCHAR wszText[512];
	CHAR szText[256];
	BSTR bsText;

	WCHAR wszCaller[512];
	CHAR szCaller[256];
	BSTR bsCaller;

	WCHAR wszRemote[512];
	CHAR szRemote[256];
	BSTR bsRemote;

	WCHAR wszRemName[512];
	CHAR szRemName[256];
	BSTR bsRemName;

	WCHAR wszLocal[512];
	CHAR szLocal[256];
	BSTR bsLocal;

	WCHAR wszLocContext[512];
	CHAR szLocContext[256];
	BSTR bsLocContext;

	switch(e.type) 
	{
        	case IAXC_EVENT_LEVELS:
			        return vb_cb_levels((int)e.ev.levels.input, (int)e.ev.levels.output);

		case IAXC_EVENT_TEXT:
            			{
				sprintf(szText,"%s", e.ev.text.message);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,szText,255,wszText,512);
				bsText = SysAllocString((BSTR)&wszText);
				ret= vb_cb_text((int)e.ev.text.type, (int)e.ev.text.callNo, bsText);
//				ret= vb_cb_text(e.ev.text.type, bsText);
				SysFreeString(bsText);
				return ret;
				}
		case IAXC_EVENT_REG:
									{
				strncpy(szCaller, e.ev.reg.caller, 255);
				//sprintf(szCaller,"%s", e.ev.reg.caller);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,szCaller,256,wszCaller,512);
				bsCaller = SysAllocString((BSTR)&wszCaller);
				ret= vb_cb_reg(bsCaller, (int)e.ev.reg.msgcount);
				SysFreeString(bsCaller);
				return ret;
				}
		case IAXC_EVENT_STATE:
            { 
				sprintf(szRemote,"%s", e.ev.call.remote);
				sprintf(szRemName,"%s", e.ev.call.remote_name);
				sprintf(szLocal,"%s", e.ev.call.local);
				sprintf(szLocContext,"%s", e.ev.call.local_context);

				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,szRemote,255,wszRemote,512);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,szRemName,255,wszRemName,512);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,szLocal,255,wszLocal,512);
				MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,szLocContext,255,wszLocContext,512);

				bsRemote = SysAllocString((BSTR)&wszRemote);
				bsRemName = SysAllocString((BSTR)&wszRemName);
				bsLocal = SysAllocString((BSTR)&wszLocal);
				bsLocContext = SysAllocString((BSTR)&wszLocContext);

				ret=vb_cb_state((int)e.ev.call.callNo, (int)e.ev.call.state, (int)e.ev.call.format, bsRemote, 
							bsRemName, bsLocal, bsLocContext);
//				ret=vb_cb_state(e.ev.call.callNo, e.ev.call.state, bsRemote, 
//							bsRemName, bsLocal, bsLocContext);
				SysFreeString(bsRemote);
				SysFreeString(bsRemName);
				SysFreeString(bsLocal);
				SysFreeString(bsLocContext);
				return ret;

			}
		default:
            return 0;  // not handled
	}
}
//--------------------------------------------------------------------------//
EXPORT int STDCALL IAX_GetFilters(void)
{
	return(iaxc_get_filters());
}

//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_SetFilters(int iFilters)
{
	iaxc_set_filters(iFilters);
}
//--------------------------------------------------------------------------//
EXPORT void STDCALL IAX_BlindTransferCall(int callNo, char *number)
{
	iaxc_blind_transfer_call(callNo, number);	
}
//--------------------------------------------------------------------------//


